-- Spatial Rift Countdown - a World of Warcraft addon
-- Copyright (C) 2019 aallkkaa <aallkkaa@gmx.com>
-- Released under the MIT license. See the LICENSE.txt file for details.

-- Enable only if player is Void Elf
local _, UnlocalizedPlayerRace = UnitRace("player");
if UnlocalizedPlayerRace ~= "VoidElf" then
	return;
else
	UnlocalizedPlayerRace = nil;
end
-- Generic stuff
local AddonName, AddonEnv = ...;
local eventsFrame = CreateFrame("Frame");
-- Make sure the UIErrorsFrame (where we output our countdown) is receiving UI_INFO_MESSAGE events
if not UIErrorsFrame:IsEventRegistered("UI_INFO_MESSAGE") then
	UIErrorsFrame:RegisterEvent("UI_INFO_MESSAGE");
	print(AddonName.. ": UIErrorsFrame is now receiving UI_INFO_MESSAGE events.");
end
-- Printing function
local timeLeftSecs = 5;	-- Spatial Rift can be used up to 5 seconds after being cast
local localizedSpellName = (GetSpellInfo(256948));
local PrintTimeLeftSeconds = function()
	UIErrorsFrame:AddMessage(localizedSpellName.. ": ".. timeLeftSecs);
	if timeLeftSecs == 0 then
		timeLeftSecs = 5;
	else
		timeLeftSecs = timeLeftSecs -1;
	end
end
-- Event handler
local eventHandler = function(...)
	local self, event, unit, arg2, arg3, spellID = ...;
	-- Check whether the event fired for one of the supported units and spell; exit otherwise
	if (unit ~= "player") or (type(spellID) ~= "number") then
		return;
	end
	if spellID == 256948 then	-- Tear rift!
		PrintTimeLeftSeconds();
		timeLeftSecsTicker = C_Timer.NewTicker(1, PrintTimeLeftSeconds, 5);
	elseif spellID == 257040 then	-- Teleport!
		timeLeftSecsTicker:Cancel();
		timeLeftSecs = 5;
	end
end
-- Event registration and handler setting
eventsFrame:RegisterEvent("UNIT_SPELLCAST_SENT");
-- eventsFrame:RegisterUnitEvent("UNIT_SPELLCAST_SENT");
eventsFrame:SetScript("OnEvent", eventHandler);
